import React, {Component, PropTypes} from 'react';
import SyntaxHighlighter, {registerLanguage} from 'react-syntax-highlighter/dist/light';
import {createElement} from 'react-syntax-highlighter';

import python from 'react-syntax-highlighter/dist/languages/python';

import * as styles from 'react-syntax-highlighter/dist/styles';

import * as R from 'ramda';

const AVAILABLE_STYLES = [
    'androidstudio', 'arduinoLight', 'arta', 'ascetic', 'atelierCaveDark',
    'atelierCaveLight', 'atelierDuneDark', 'atelierDuneLight',
    'atelierEstuaryDark', 'atelierEstuaryLight',
    'atelierForestDark', 'atelierForestLight', 'atelierHeathDark',
    'atelierHeathLight', 'atelierLakesideDark', 'atelierLakesideLight',
    'atelierPlateauDark', 'atelierPlateauLight', 'atelierSavannaDark',
    'atelierSavannaLight', 'atelierSeasideDark', 'atelierSeasideLight',
    'atelierSulphurpoolDark', 'atelierSulphurpoolLight', 'atomOneDark',
    'atomOneLight', 'brownPaper', 'codepenEmbed', 'colorBrewer',
    'darcula', 'dark', 'darkula', 'defaultStyle', 'docco', 'dracula',
    'far', 'foundation', 'githubGist', 'github', 'googlecode', 'grayscale',
    'gruvboxDark', 'gruvboxLight', 'hopscotch', 'hybrid', 'idea', 'irBlack',
    'kimbieDark', 'kimbieLight', 'magula', 'monoBlue', 'monokaiSublime',
    'monokai', 'obsidian', 'ocean', 'paraisoDark', 'paraisoLight',
    'pojoaque', 'purebasic', 'qtcreatorDark', 'qtcreatorLight',
    'railscasts', 'rainbow', 'routeros', 'schoolBook', 'solarizedDark',
    'solarizedLight', 'sunburst', 'tomorrowNightBlue', 'tomorrowNightBright',
    'tomorrowNightEighties', 'tomorrowNight', 'tomorrow', 'vs',
    'vs2015', 'xcode', 'xt256', 'zenburn'
];

registerLanguage('python', python);

class DashSyntaxHighlighter extends Component {
    render() {
        const {code, theme, style} = this.props;
        return (
            <SyntaxHighlighter
                language={'python'}
                style={styles[theme]}
                wrapLines={true}
                customStyle={R.merge({
                    'paddingLeft': '10px',
                    'paddingTop': 0,
                    'margin': 0,
                    'overflowX': 'scroll'
                }, style)}
            >
                {code}
            </SyntaxHighlighter>
        );
    }
}

DashSyntaxHighlighter.propTypes = {
    code: PropTypes.string,
    theme: PropTypes.oneOf(AVAILABLE_STYLES),
    style: PropTypes.object,
}

export default DashSyntaxHighlighter;
